//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   1
#property indicator_label1  "Laguerre filter"
#property indicator_type1   DRAW_COLOR_LINE
#property indicator_color1  clrLimeGreen,clrOrange
#property indicator_style1  STYLE_SOLID
#property indicator_width1  2

//
//
//
//
//

input int LookBack = 20; // Lookback period
input int Median   = 5;  // Median for adapting

//
//
//
//
//
//

double lf[];
double colorBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int OnInit()
{
   SetIndexBuffer(0,lf,INDICATOR_DATA); 
   SetIndexBuffer(1,colorBuffer,INDICATOR_COLOR_INDEX); 
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double diff[];
double sortDiff[];
int OnCalculate (const int rates_total,
                 const int prev_calculated,
                 const int begin,
                 const double& price[] )
{
      if (ArraySize(diff)!=rates_total) ArrayResize(diff,rates_total);
      if (ArraySize(sortDiff)!=Median)  ArrayResize(sortDiff,Median);

   //
   //
   //
   //
   //

   for (int i=(int)MathMax(prev_calculated-1,1); i<rates_total; i++)
   {
      diff[i] = MathAbs(price[i]-lf[i-1]);
         double hi  = diff[i];
         double lo  = diff[i];
            for (int j=1; j<LookBack & (i-j)>=0; j++) 
            {
               hi = MathMax(hi,diff[i-j]);
               lo = MathMin(lo,diff[i-j]);
            }
         double alpha = 0;
         if (hi!=lo)    
         {
            for (int j=0; j<Median && (i-j)>=0; j++) sortDiff[j] = (diff[i-j]-lo)/(hi-lo);
            ArraySort(sortDiff);
               if (MathMod(Median,2.0) != 0) alpha =  sortDiff[Median/2];         
               else                          alpha = (sortDiff[Median/2]+sortDiff[(Median/2)-1])/2;
         }

      //
      //
      //
      //
      //
      
      lf[i] = iLaGuerreFilter(price[i],1-alpha,rates_total,i,0);
      colorBuffer[i] = colorBuffer[i-1];
          if (lf[i] > lf[i-1]) colorBuffer[i]= 0;
          if (lf[i] < lf[i-1]) colorBuffer[i]= 1;
   }
   return(rates_total);
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workLagFil[][4];
double iLaGuerreFilter(double price, double gamma, int bars, int i, int instanceNo=0)
{
   if (ArrayRange(workLagFil,0)!=bars) ArrayResize(workLagFil,bars); instanceNo*=4;
   if (price==EMPTY_VALUE) return(0);
   if (gamma<=0 || i<1) return(price);

   //
   //
   //
   //
   //
      
   workLagFil[i][instanceNo+0] = (1.0 - gamma)*price                                                + gamma*workLagFil[i-1][instanceNo+0];
	workLagFil[i][instanceNo+1] = -gamma*workLagFil[i][instanceNo+0] + workLagFil[i-1][instanceNo+0] + gamma*workLagFil[i-1][instanceNo+1];
	workLagFil[i][instanceNo+2] = -gamma*workLagFil[i][instanceNo+1] + workLagFil[i-1][instanceNo+1] + gamma*workLagFil[i-1][instanceNo+2];
	workLagFil[i][instanceNo+3] = -gamma*workLagFil[i][instanceNo+2] + workLagFil[i-1][instanceNo+2] + gamma*workLagFil[i-1][instanceNo+3];

   //
   //
   //
   //
   //
 
   return((workLagFil[i][instanceNo+0]+2.0*workLagFil[i][instanceNo+1]+2.0*workLagFil[i][instanceNo+2]+workLagFil[i][instanceNo+3])/6.0);
}